from pathlib import Path
import requests
from datetime import datetime


def get_files_for_compare(path, host) -> datetime:
    main_path = Path(path)
    r = '/*.py/'
    url = f'{host}/api/v1/SummaryAPIView/'  # ?
    arr_response = []
    if main_path.exists():
        all_files = [p for p in main_path.rglob("*.py")]
        groups_files = group_by(all_files, main_path)
        res_time = datetime(2024, 5, 7)
        for g in groups_files:
            temp_file = g[0]
            for k in range(1, len(g) - 1):
                for j in range(k + 1, len(g)):
                    try:
                        with open(g[k], 'r') as file1, open(g[j], 'r') as file2, open(temp_file, 'r') as file_template:
                            start_time = datetime.now()
                            response = requests.post(url, files={'file1': file1, 'file2': file2,
                                                                 'file_template': file_template},
                                                     data={'gram_size': 8, 'window_size': 3})
                            cur_time = datetime.now() - start_time
                            res_time += cur_time
                            arr_response.append({'resp': response.json(), 'to_path': Path(f'{main_path}\\report.txt'),
                                                 'abs_path': {'absolute_path_to_file1': g[k],
                                                              'absolute_path_to_file2': g[j],
                                                              'absolute_path_to_file_template': temp_file}})
                    except IOError as e:
                        print("IOError:" + IOError.strerror)
        sorted_response(arr_response)
        return res_time


def group_by(files, main_path):
    ind = len(main_path.parts)
    res = []
    if len(files) != 0:
        d = dict()
        for file in files:
            key = "".join(file.parts[ind + 1:])
            if d.get(key) is None:
                d[key] = [file]
            else:
                d[key].append(file)

        for k in d:
            sorted(d[k], key=lambda x: 'templates' in x.parts)
            res.append(list(d[k]))
        return res


def sorted_response(arr_response: list[dict]):
    sorted_arr = sorted(arr_response, key=lambda d: d['resp']['res']['coeff'], reverse=True)
    for d in sorted_arr:
        write_to_file_json(d['resp']['res'], d['to_path'], d['abs_path'])


def write_to_file_json(response, to_path, absolute_path):
    t = [set(v.parts) for k, v in absolute_path.items()]
    f, s = t[:-1]
    names = set(f - s)
    names.update(s - f)
    names = list(names)
    with open(to_path, 'a+') as report:
        report.write(f'Сравнение работ {names[0]} - {names[1]}\n')
        report.write("Отчет:\n")
        for k, v in response.items():
            if k == 'q1':
                var = [f'{k}: {v} \n' for k, v in absolute_path.items()]
                report.writelines(var)
            report.write(f'{k}: {v}\n')

        report.write(
            "--------------------------------------------------------------------------------------------------\n")
