from .method_builder import MethodBuilder
from .fp_method import FpMethodResult


class MethodConfigurator():
    builder: MethodBuilder

    def __init__(self, builder: MethodBuilder) -> None:
        super().__init__()
        self.builder = builder
        if self.builder is None:
            raise AttributeError("Builder cannot be empty")

    def change_builder(self, new_builder: MethodBuilder):
        self.builder = new_builder

    def make_method(self) -> FpMethodResult:
        self.builder.pre_processing_step()
        self.builder.processing_step()
        return self.builder.post_processing_step()


class VariablesCompare:

    def __init__(self, file1, file2, clone_part_1, clone_part_2, f1, f2, path1, path2):
        self.file1 = file1
        self.file2 = file2
        self.clone_part_1 = clone_part_1
        self.clone_part_2 = clone_part_2
        self.f1 = f1
        self.f2 = f2
        self.path1 = path1
        self.path2 = path2
