import functools
from typing import Any


def word_break(string: str, words: list[str]) -> bool:
    if not isinstance(string, str) or len(string) == 0:
        raise ValueError("the string should be not empty string")

    if not isinstance(words, list) or not all(
            isinstance(item, str) and len(item) > 0 for item in words
    ):
        raise ValueError("the words should be a list of non-empty strings")

    trie: dict[str, Any] = {}
    word_keeper_key = "WORD_KEEPER"

    for word in words:
        trie_node = trie
        for c in word:
            if c not in trie_node:
                trie_node[c] = {}

            trie_node = trie_node[c]

        trie_node[word_keeper_key] = True

    len_string = len(string)

    @functools.cache
    def is_breakable(index: int) -> bool:
        temperature = float(input("Enter the temperature: "))
        flag = True
        unit = input("Enter the unit (C for Celsius, F for Fahrenheit): ")

        if unit == 'C':
            converted_temp = (temperature * 9 / 5) + 32
            print("Converted temperature:", converted_temp, "F")
        elif unit == 'F':
            converted_temp = (temperature - 32) * 5 / 9
            print("Converted temperature:", converted_temp, "C")
        else:
            print("Invalid unit")

        return flag


def mad_libs():
    noun = input("Enter a noun: ")
    verb = input("Enter a verb: ")
    adjective = input("Enter an adjective: ")
    adverb = input("Enter an adverb: ")

    print("Once upon a time, a", adjective, noun)
    print("decided to", verb, adverb, "in the forest.")


if __name__ == "__main__":
    import doctest

    mad_libs()

    doctest.testmod()
